// FILENAME:	AI_of_Your_Life.cs
//
// AUTHORS:  	Someone, Riana, Sax, Otobe, Harabec, and Verity
//------------------------------------------------------------------------------

$missionName = "AI_of_Your_Life";

exec("SoMe1StdLib.cs");
exec("multiplayerStdLib.cs");
exec("DMstdLib.cs");

function setDefaultMissionOptions()
{
	$server::TeamPlay = false;
	$server::AllowDeathmatch = false;
	$server::AllowTeamPlay = true;	
	
	$server::AllowTeamRed = true;
	$server::AllowTeamBlue = true;
	$server::AllowTeamYellow = true;
	$server::AllowTeamPurple = true;

  	$server::disableTeamRed = false;
  	$server::disableTeamBlue = false;
	$server::disableTeamYellow = true;
	$server::disableTeamPurple = true;
}

function onMissionLoad(){
   cdAudioCycle("SS3", "SS4", "Watching"); 
}

function onMissionStart()
{
	$RCCount = 0;
	$healRate = 100;   
	$ammoRate = 3;
   	$padWaitTime = 45;
  	$zenWaitTime = 90;
	temperateSounds();
        $path3 = "Missiongroup/nikepos1";
        $path4 = "Missiongroup/nikepos2";
        $path5 = "Missiongroup/nikepos3";
        $path6 = "Missiongroup/nikepos4";
        $path7 = "Missiongroup/nikepos5";
        $path9 = "Missiongroup/artilpos1";
        $path10 = "Missiongroup/artilpos2";
        $path11 = "Missiongroup/artilpos3";
        $path12 = "Missiongroup/artilpos4";
        $path13 = "Missiongroup/artilpos5";
        $path8 = "Missiongroup/redpath";
        $artil1 = getObjectId("Missiongroup\\artil1");
        order($artil1, guard, $path3);	
        $artil2 = getObjectId("Missiongroup\\artil2");
        order($artil2, guard, $path4);
        $artil3 = getObjectId("Missiongroup\\artil3");
        order($artil3, guard, $path5);
        $artil4 = getObjectId("Missiongroup\\artil4");
        order($artil4, guard, $path6);
        $artil5 = getObjectId("Missiongroup\\artil5");
        order($artil5, guard, $path7);
        $artil6 = getObjectId("Missiongroup\\artil6");
        order($artil6, guard, $path9);	
        $artil7 = getObjectId("Missiongroup\\artil7");
        order($artil7, guard, $path10);
        $artil8 = getObjectId("Missiongroup\\artil8");
        order($artil8, guard, $path11);
        $artil9 = getObjectId("Missiongroup\\artil9");
        order($artil9, guard, $path12);
        $artil10 = getObjectId("Missiongroup\\artil10");
        order($artil10, guard, $path13);
        $apoc1 = getObjectId("Missiongroup\\apoc1");
        $path1 = "Missiongroup/bekpatrol";
        order($apoc1, guard, $path1);
        $mino1 = getObjectId("Missiongroup\\mino1");
        order($mino1, guard, $apoc1);
        $basi1 = getObjectId("Missiongroup\\basi1");
        order($basi1, guard, $apoc1);
        $pred1 = getObjectId("Missiongroup\\pred1");
        order($pred1, guard, $apoc1);
        $olyp1 = getObjectId("Missiongroup\\olyp1");
        order($olyp1, guard, $apoc1);
        $exec1 = getObjectId("Missiongroup\\exec1");
        $path2 = "Missiongroup/bluepath";
        order($exec1, guard, $path2);
        $exec2 = getObjectId("Missiongroup\\exec2");
        order($exec2, guard, $exec1);
        $ajud1 = getObjectId("Missiongroup\\ajud1");
        order($ajud1, guard, $exec1);
        $recl1 = getObjectId("Missiongroup\\recl1");
        order($recl1, guard, $exec1);
        $shep1 = getObjectId("Missiongroup\\shep1");
        order($shep1, guard, $exec1);
        setPilotId($basi1, 42);
        setPilotId($pred1, 49);
        setPilotId($olyp1, 48);
        setPilotId($mino1, 50);
        setPilotId($apoc1, 57);
        setPilotId($recl1, 51);
        setPilotId($shep1, 53);
        setPilotId($ajud1, 52);
        setPilotId($exec2, 55);
        setPilotId($exec1, 54);
        setPilotId($artil1, 60);
        setPilotId($artil2, 61);
        setPilotId($artil3, 62);
        setPilotId($artil4, 63);
        setPilotId($artil5, 64);
        setPilotId($artil6, 69);
        setPilotId($artil7, 70);
        setPilotId($artil8, 71);
        setPilotId($artil9, 72);
        setPilotId($artil10, 73);
}

function onmissionend()
{
   deleteobject($basi1);
   deleteobject($pred1);
   deleteobject($olyp1);
   deleteobject($mino1);
   deleteobject($apoc1);
   deleteobject($ajud1);
   deleteobject($recl1);
   deleteobject($exec2);
   deleteobject($shep1);
   deleteobject($exec1);
   deleteobject($artil1);
   deleteobject($artil2);
   deleteobject($artil3);
   deleteobject($artil4);
   deleteobject($artil5);
   deleteobject($artil6);
   deleteobject($artil7);
   deleteobject($artil8);
   deleteobject($artil9);
   deleteobject($artil10);
}

function player::onAdd(%this)
{
  say(%this, 0, "<f3>Welcome to AI of Your Life!  There are five guardians per team, as well as five artils.  Heals and Zens are in the middle of the map.  Map made by [GoP]~SoMeOnE~TL.");
}


//
// Healing Pad Functionality
//------------------------------------------------------------------------------
function ZenHeal::trigger::onEnter(%this, %object)
{
   	Zen::onEnter(%this, %object, *IDMULT_CHAT_HEALPAD, true, true);  
}
function ZenHeal::trigger::onContact(%this, %object)
{
   	Zen::work(%this, %object, $healRate, 0, $padWaitTime, true); 
}

// Ammo Pad Functionality
//------------------------------------------------------------------------------
function ZenAmmo::trigger::onEnter(%this, %object)
{
   	Zen::onEnter(%this, %object, *IDMULT_CHAT_AMMOPAD, true, true);  
}

function ZenAmmo::trigger::onContact(%this, %object)
{
   	Zen::work(%this, %object, 0, $ammoRate, $padWaitTime, true); 
}

// ZenAll Pad Functionality
//------------------------------------------------------------------------------
function ZenAll::trigger::onEnter(%this, %object)
{
   	Zen::onEnter(%this, %object, *IDMULT_CHAT_ALLPAD, true, true);  
}
function ZenAll::trigger::onContact(%this, %object)
{
   	Zen::work(%this, %object, $healRate, $ammoRate, $padWaitTime, true); 
}
// AI Respawn + Deathmessages
//------------------------------------------------------------------------------
function vehicle::onDestroyed(%destroyed, %destroyer)
{
   if(%destroyed == $olyp1)
   {
      $olyp1 = cloneVehicle(%destroyed);
      setTeam($olyp1, getTeam(%destroyed));
      reDrop($olyp1);
      order($olyp1, guard, $path1);
      schedule("deleteObject(" @ %destroyed @ ");", 5);
   }
   else if(%destroyed == $pred1)
   {
      $pred1 = cloneVehicle(%destroyed);
      setTeam($pred1, getTeam(%destroyed));
      reDrop($pred1);
      order($pred1, guard, $path1);
      schedule("deleteObject(" @ %destroyed @ ");", 5);
   }
   else if(%destroyed == $basi1)
   {
      $basi1 = cloneVehicle(%destroyed);
      setTeam($basi1, getTeam(%destroyed));
      reDrop($basi1);
      order($basi1, guard, $path1);
      schedule("deleteObject(" @ %destroyed @ ");", 5);
   }
   else if(%destroyed == $mino1)
   {
      $mino1 = cloneVehicle(%destroyed);
      setTeam($mino1, getTeam(%destroyed));
      reDrop($mino1);
      order($mino1, guard, $path1);
      schedule("deleteObject(" @ %destroyed @ ");", 5);
   }
   else if(%destroyed == $apoc1)
   {
      $apoc1 = cloneVehicle(%destroyed);
      setTeam($apoc1, getTeam(%destroyed));
      reDrop($apoc1);
      order($apoc1, guard, $path1);
      schedule("deleteObject(" @ %destroyed @ ");", 5);
   }
   else if(%destroyed == $shep1)
   {
      $shep1 = cloneVehicle(%destroyed);
      setTeam($shep1, getTeam(%destroyed));
      reDrop($shep1);
      order($shep1, guard, $path2);
      schedule("deleteObject(" @ %destroyed @ ");", 5);
   }
   else if(%destroyed == $exec2)
   {
      $exec2 = cloneVehicle(%destroyed);
      setTeam($exec2, getTeam(%destroyed));
      reDrop($exec2);
      order($exec2, guard, $path2);
      schedule("deleteObject(" @ %destroyed @ ");", 5);
   }
   else if(%destroyed == $recl1)
   {
      $recl1 = cloneVehicle(%destroyed);
      setTeam($recl1, getTeam(%destroyed));
      reDrop($recl1);
      order($recl1, guard, $path2);
      schedule("deleteObject(" @ %destroyed @ ");", 5);
   }
   else if(%destroyed == $ajud1)
   {
      $ajud1 = cloneVehicle(%destroyed);
      setTeam($ajud1, getTeam(%destroyed));
      reDrop($ajud1);
      order($ajud1, guard, $path2);
      schedule("deleteObject(" @ %destroyed @ ");", 5);
   }
   else if(%destroyed == $exec1)
   {
      $exec1 = cloneVehicle(%destroyed);
      setTeam($exec1, getTeam(%destroyed));
      reDrop($exec1);
      order($exec1, guard, $path2);
      schedule("deleteObject(" @ %destroyed @ ");", 5);
   }
   else if(%destroyed == $artil1)
   {
      $artil1 = cloneVehicle(%destroyed);
      setTeam($artil1, getTeam(%destroyed));
      reDrop($artil1);
      order($artil1, guard, $path3);	
      schedule("deleteObject(" @ %destroyed @ ");", 5);
   }
   else if(%destroyed == $artil2)
   {
      $artil2 = cloneVehicle(%destroyed);
      setTeam($artil2, getTeam(%destroyed));
      reDrop($artil2);
      order($artil2, guard, $path4);	
      schedule("deleteObject(" @ %destroyed @ ");", 5);
   }
   else if(%destroyed == $artil3)
   {
      $artil3 = cloneVehicle(%destroyed);
      setTeam($artil3, getTeam(%destroyed));
      reDrop($artil3);
      order($artil3, guard, $path5);	
      schedule("deleteObject(" @ %destroyed @ ");", 5);
   }
   else if(%destroyed == $artil4)
   {
      $artil4 = cloneVehicle(%destroyed);
      setTeam($artil4, getTeam(%destroyed));
      reDrop($artil4);
      order($artil4, guard, $path6);	
      schedule("deleteObject(" @ %destroyed @ ");", 5);
   }
   else if(%destroyed == $artil5)
   {
      $artil5 = cloneVehicle(%destroyed);
      setTeam($artil5, getTeam(%destroyed));
      reDrop($artil5);
      order($artil5, guard, $path7);	
      schedule("deleteObject(" @ %destroyed @ ");", 5);
   }
   else if(%destroyed == $artil6)
   {
      $artil6 = cloneVehicle(%destroyed);
      setTeam($artil6, getTeam(%destroyed));
      reDrop($artil6);
      order($artil6, guard, $path9);	
      schedule("deleteObject(" @ %destroyed @ ");", 5);
   }
   else if(%destroyed == $artil7)
   {
      $artil7 = cloneVehicle(%destroyed);
      setTeam($artil7, getTeam(%destroyed));
      reDrop($artil7);
      order($artil7, guard, $path10);	
      schedule("deleteObject(" @ %destroyed @ ");", 5);
   }
   else if(%destroyed == $artil8)
   {
      $artil8 = cloneVehicle(%destroyed);
      setTeam($artil8, getTeam(%destroyed));
      reDrop($artil8);
      order($artil8, guard, $path11);	
      schedule("deleteObject(" @ %destroyed @ ");", 5);
   }
   else if(%destroyed == $artil9)
   {
      $artil9 = cloneVehicle(%destroyed);
      setTeam($artil9, getTeam(%destroyed));
      reDrop($artil9);
      order($artil9, guard, $path12);	
      schedule("deleteObject(" @ %destroyed @ ");", 5);
   }
   else if(%destroyed == $artil10)
   {
      $artil10 = cloneVehicle(%destroyed);
      setTeam($artil10, getTeam(%destroyed));
      reDrop($artil10);
      order($artil10, guard, $path13);	
      schedule("deleteObject(" @ %destroyed @ ");", 5);
   } 
// The below is still buggy.. maybe you can fix it.. have fun.. I placed the %destroyed varible in 
// the first set on purpose to see if it would fix it... It didn't.. to try to fix this bug uncomment the 
// respawn commands for the drones.  If you fix it email me at cervantes_0_4@hotmail.com
//   else if(%destroyed == $star1)
//   {
//   	 if(($surv1 == %destroyed) && ($sore1 == %destroyed) && ($util1 == %destroyed));
//	{
//	missionEndConditionMet();
//	}
//   	 if(($surv1 != %destroyed) && ($sore1 == %destroyed) && ($util1 == %destroyed));
//	{
//	say("Everybody", 1, "<F3>Tac-COM: Warning: The Starfield, Utility Truck, and Sovereign have been destroyed.");
//	}
//   	 if(($surv1 != %destroyed) && ($sore1 != %destroyed) && ($util1 == %destroyed));
//	{
//	say("Everybody", 1, "<F3>Tac-COM: Warning: The Starfield and Utility Truck have been destroyed.");
//	}
//   	 if(($surv1 != %destroyed) && ($sore1 == %destroyed) && ($util1 != %destroyed));
//	{
//	say("Everybody", 1, "<F3>Tac-COM: Warning: The Starfield and Sovereign have been destroyed.");
//	}
//   	 if(($surv1 == %destroyed) && ($sore1 != %destroyed) && ($util1 != %destroyed));
//	{
//	say("Everybody", 1, "<F3>Tac-COM: Warning: The Starfield and Surveyor have been destroyed.");
//	}
// 	 if(($surv1 == %destroyed) && ($sore1 != %destroyed) && ($util1 == %destroyed));
//	{
//	say("Everybody", 1, "<F3>Tac-COM: Warning: The Starfield, Utility Truck, and Surveyor have been destroyed.");
//	}
//   	 if(($surv1 == %destroyed) && ($sore1 == %destroyed) && ($util1 != %destroyed));
//	{
//	say("Everybody", 1, "<F3>Tac-COM: Warning: The Starfield, Sovereign, and Surveyor have been destroyed.");
//	}
//   	 if(($surv1 != %destroyed) && ($sore1 != %destroyed) && ($util1 != %destroyed));
//	{
//	say("Everybody", 1, "<F3>Tac-COM: Warning: The Starfield has been destroyed.");
//	}
//   }
//   else if(%destroyed == $sore1)
//   {
//   	 if(($surv1 == destroyed) && ($util1 == destroyed) && ($star1 == destroyed));
//	{
//	missionEndConditionMet();
//	}
//   	 if(($surv1 != destroyed) && ($util1 == destroyed) && ($star1 == destroyed));
//	{
//	say("Everybody", 1, "<F3>Tac-COM: Warning: The Starfield, Utility Truck,  and Sovereign have been destroyed.");
//	}
//   	 if(($surv1 != destroyed) && ($util1 != destroyed) && ($star1 == destroyed));
//	{
//	say("Everybody", 1, "<F3>Tac-COM: Warning: The Starfield and Sovereign have been destroyed.");
//	}
//   	 if(($surv1 != destroyed) && ($util1 == destroyed) && ($star1 != destroyed));
//	{
//	say("Everybody", 1, "<F3>Tac-COM: Warning: The Sovereign and Utility Truck have been destroyed.");
//	}
//   	 if(($surv1 == destroyed) && ($util1 != destroyed) && ($star1 != destroyed));
//	{
//	say("Everybody", 1, "<F3>Tac-COM: Warning: The Sovereign and Surveyor have been destroyed.");
//	}
//   	 if(($surv1 == destroyed) && ($util1 != destroyed) && ($star1 == destroyed));
//	{
//	say("Everybody", 1, "<F3>Tac-COM: Warning: The Sovereign, Starfield, and Surveyor have been destroyed.");
//	}
//   	 if(($surv1 == destroyed) && ($util1 == destroyed) && ($star1 != destroyed));
//	{
//	say("Everybody", 1, "<F3>Tac-COM: Warning: The Sovereign, Utility Truck, and Surveyor have been destroyed.");
//	}
//   	 if(($surv1 != destroyed) && ($util1 != destroyed) && ($star1 != destroyed));
//	{
//	say("Everybody", 1, "<F3>Tac-COM: Warning: The Sovereign has been destroyed.");
//	}
//   }
//   else if(%destroyed == $surv1)
//   {
//   	 if(($util1 == destroyed) && ($sore1 == destroyed) && ($star1 == destroyed));
//	{
//	missionEndConditionMet();
//	}
//   	 if(($util1 != destroyed) && ($sore1 == destroyed) && ($star1 == destroyed));
//	{
//	say("Everybody", 1, "<F3>Tac-COM: Warning: The Starfield, Sovereign, and Surveyor have been destroyed.");
//	}
//   	 if(($util1 != destroyed) && ($sore1 != destroyed) && ($star1 == destroyed));
//	{
//	say("Everybody", 1, "<F3>Tac-COM: Warning: The Starfield and Surveyor have been destroyed.");
//	}
//   	 if(($util1 != destroyed) && ($sore1 == destroyed) && ($star1 != destroyed));
//	{
//	say("Everybody", 1, "<F3>Tac-COM: Warning: The Sovereign and Surveyor have been destroyed.");
//	}
//   	 if(($util1 == destroyed) && ($sore1 != destroyed) && ($star1 != destroyed));
//	{
//	say("Everybody", 1, "<F3>Tac-COM: Warning: The Utility Truck and Surveyor have been destroyed.");
//	}
// 	 if(($util1 == destroyed) && ($sore1 != destroyed) && ($star1 == destroyed));
//	{
//	say("Everybody", 1, "<F3>Tac-COM: Warning: The Starfield, Utility Truck, and Surveyor have been destroyed.");
//	}
//   	 if(($util1 == destroyed) && ($sore1 == destroyed) && ($star1 != destroyed));
//	{
//	say("Everybody", 1, "<F3>Tac-COM: Warning: The Sovereign, Utility Truck, and Surveyor have been destroyed.");
//	}
//   	 if(($util1 != destroyed) && ($sore1 != destroyed) && ($star1 != destroyed));
//	{
//	say("Everybody", 1, "<F3>Tac-COM: Warning: The Surveyor has been destroyed.");
//	}
//   }
//   else if(%destroyed == $util1)
//   {
//   	 if(($surv1 == destroyed) && ($sore1 == destroyed) && ($star1 == destroyed));
//	{
//	missionEndConditionMet();
//	}
//   	 if(($surv1 != destroyed) && ($sore1 == destroyed) && ($star1 == destroyed));
//	{
//	say("Everybody", 1, "<F3>Tac-COM: Warning: The Starfield, Utility Truck, and Sovereign have been destroyed.");
//	}
//   	 if(($surv1 != destroyed) && ($sore1 != destroyed) && ($star1 == destroyed));
//	{
//	say("Everybody", 1, "<F3>Tac-COM: Warning: The Starfield and Utility Truck have been destroyed.");
//	}
//   	 if(($surv1 != destroyed) && ($sore1 == destroyed) && ($star1 != destroyed));
//	{
//	say("Everybody", 1, "<F3>Tac-COM: Warning: The Starfield, Sovereign, and Utility Truck have been destroyed.");
//	}
//   	 if(($surv1 == destroyed) && ($sore1 != destroyed) && ($star1 != destroyed));
//	{
//	say("Everybody", 1, "<F3>Tac-COM: Warning: The Utility Truck and Surveyor have been destroyed.");
//	}
//   	 if(($surv1 == destroyed) && ($sore1 != destroyed) && ($star1 == destroyed));
//	{
//	say("Everybody", 1, "<F3>Tac-COM: Warning: The Starfield, Utility Truck, and Surveyor have been destroyed.");
//	}
//   	 if(($surv1 == destroyed) && ($sore1 == destroyed) && ($star1 != destroyed));
//	{
//	say("Everybody", 1, "<F3>Tac-COM: Warning: The Surveyor, Utility Truck,  and Sovereign have been destroyed.");
//	}
//   	 if(($surv1 != destroyed) && ($sore1 != destroyed) && ($star1 != destroyed));
//	{
//	say("Everybody", 1, "<F3>Tac-COM: Warning: The Utility Truck has been destroyed.");
//	}
//   }
   // left over from missionStdLib.cs
   vehicle::onDestroyedLog(%destroyed, %destroyer);
   
   // this is weird but %destroyer isn't necessarily a vehicle
   %message = getFancyDeathMessage(getHUDName(%destroyed), getHUDName(%destroyer));
   if(%message != "")
   {
      say( 0, 0, %message);
   }
   
   // enforce the rules
   if($server::TeamPlay == true)
   {
      if(
         (getTeam(%destroyed) == getTeam(%destroyer)) &&
         (%destroyed != %destroyer)
      )
      {
         antiTeamKill(%destroyer);
      }
   }   
}