// FILENAME:	IT_is_King.cs
//
// AUTHORS:  	Some1 & pD Also Thx to MIB Sentinal for the Code
//------------------------------------------------------------------------------

$missionName = "IT_is_King";

exec("multiplayerStdLib.cs");
exec("DMstdLib.cs");

function setDefaultMissionOptions()
{
	$server::TeamPlay = false;
	$server::AllowDeathmatch = true;
	$server::AllowTeamPlay = false;	
	
	$server::AllowTeamRed = true;
	$server::AllowTeamBlue = false;
	$server::AllowTeamYellow = false;
	$server::AllowTeamPurple = false;
}

function onMissionLoad(){
   cdAudioCycle("yougot", "newtech");
}
// move the map
$server::HudMapViewOffsetX = -1500;
$server::HudMapViewOffsetY = 2500;

function onMissionStart()
{
	$healRate = 100;   
	$ammoRate = 3;
   	$padWaitTime = 45;
  	$zenWaitTime = 90;
	
	temperateSounds();
}

// Healing Pad Functionality
//------------------------------------------------------------------------------
function ZenHeal::trigger::onEnter(%this, %object)
{
   	Zen::onEnter(%this, %object, *IDMULT_CHAT_HEALPAD, true, true);  
}
function ZenHeal::trigger::onContact(%this, %object)
{
   	Zen::work(%this, %object, $healRate, 0, $padWaitTime, true); 
}

// Ammo Pad Functionality
//------------------------------------------------------------------------------
function ZenAmmo::trigger::onEnter(%this, %object)
{
   	Zen::onEnter(%this, %object, *IDMULT_CHAT_AMMOPAD, true, true);  
}

function ZenAmmo::trigger::onContact(%this, %object)
{
   	Zen::work(%this, %object, 0, $ammoRate, $padWaitTime, true); 
}

// ZenAll Pad Functionality
//------------------------------------------------------------------------------
function ZenAll::trigger::onEnter(%this, %object)
{
   	Zen::onEnter(%this, %object, *IDMULT_CHAT_ALLPAD, true, true);  
}
function ZenAll::trigger::onContact(%this, %object)
{
   	Zen::work(%this, %object, $healRate, $ammoRate, $padWaitTime, true); 
}

function player::onAdd(%this)
{
  say(%this, 0, "<f3>Welcome to IT is King!  This map is based on the very fun game IT.  Last one IT wins.  To be IT you must kill IT.  If IT commits suicide, next to spawn is IT.  Map made by [GoP]~SoMeOnE~TL.");
}

// IT Code
//------------------------------------------------------------------------------
function onMissionStart()
{
   $it = "Nobody";
}

function vehicle::onAdd(%vehicleId)
{
   if($it == "Nobody")
   {
      $it = %vehicleId;
      say("Everybody", 1, getHudName(%vehicleId) @ " is now IT!", "sfx_siren.wav");
   }
}

function vehicle::onDestroyed(%destroyed, %destroyer)
{
   if(%destroyed == $it)
   {
      if(%destroyed != %destroyer)
      {
         $it = %destroyer;
         say("Everybody", 1, getHudName(%destroyer) @ " is now IT!");
      }
      else if(%destroyed == %destroyer)
      {
         $it = "Nobody";
         say("Everybody", 1, "IT has committed suicide!", "ee_pd22.WAV");
      }
   }
   // left over from missionStdLib.cs
   vehicle::onDestroyedLog(%destroyed, %destroyer);
   
   // this is weird but %destroyer isn't necessarily a vehicle
   %message = getFancyDeathMessage(getHUDName(%destroyed), getHUDName(%destroyer));
   if(%message != "")
   {
      say( 0, 0, %message);
   }
   
   // enforce the rules
   if($server::TeamPlay == true)
   {
      if(
         (getTeam(%destroyed) == getTeam(%destroyer)) &&
         (%destroyed != %destroyer)
      )
      {
         antiTeamKill(%destroyer);
      }
   }   
}

function onMissionEnd()
{
   if($it == "Nobody")
   {
      say("Everybody", 1, "No one won!", "Mission_fail.WAV");
   }
   else if($it != "Nobody")
   {
      messageBox(%player, getHudName($it) @ " has won the game!!");
   }
}

function vehicle::onScan(%scanned, %scanner)
{
      say("Everybody", 1, "Hey what's up?", "ee_pd09.WAV");
}